﻿@using Business.Repository.IRepository
@using Models.PlayerData
@using Models.TeamData
@inject IModalDialogService ModalDialog
@inject IJSRuntime JsRuntime
@inject ITeamPlayerRepository TeamPlayerRepository
@inject IPlayerRepository PlayerRepository
@inject NavigationManager NavigationManager
@inject Blazored.LocalStorage.ILocalStorageService localStorage
<div class="row mt-4">
    <div class="col-12">
        <label>Search</label>
        <input type="text" placeholder="Search by name..." @bind="SearchText" @bind:event="oninput" />
        <table class="table table-bordered table-hover">
            <thead>
                <tr>
                    <th>#</th>
                    <th>Name</th>
                    <th>
                        Actions
                    </th>
                </tr>
            </thead>
            <tbody>
                @if (Players.Any())
                {
                    int i = 1;
                    @foreach (var player in Players.Where(x => x.Name.ToLower().Contains(SearchText.ToLower())).Where(x => x.Surname.ToLower().Contains(SearchText.ToLower())))
                    {
                        @if (SelectedPlayers.Contains(player))
                        {
                            <tr style="background-color:aquamarine">
                                <td width="10%">@i</td>
                                @{i++;}
                                <td width="70%">@player.Name @player.Surname</td>
                                <td width="20%">
                                    <button class="btn btn-danger" @onclick="() => HandleRemove(player)">Remove</button>
                                </td>
                            </tr>
                        }
                        else
                        {
                            <tr>
                                <td width="10%">@i</td>
                                @{i++;}
                                <td width="70%">@player.Name @player.Surname</td>
                                <td width="20%">
                                    <button class="btn btn-success" @onclick="() => HandleAdd(player)">Add</button>
                                </td>
                            </tr>
                        }
                    }
                }
                else
                {
                    <tr>
                        <td colspan="5">No records found</td>
                    </tr>
                }
            </tbody>
        </table>
        <button class="btn btn-secondary" @onclick="() => HandleCreateUpdate()">Save</button>
    </div>
</div>


@code {
    [Parameter]
    public int TeamSeasonId { get; set; }
    [CascadingParameter]
    BlazoredModalInstance ModalInstance { get; set; }

    public IEnumerable<PlayerDTO> Players { get; set; } = new List<PlayerDTO>();
    public List<PlayerDTO> SelectedPlayers { get; set; } = new List<PlayerDTO>();
    public TeamPlayerDTO TeamPlayerModel { get; set; } = new TeamPlayerDTO();
    public int Sport { get; set; }
    public int Season { get; set; }

    public string SearchText = "";

    protected override async Task OnInitializedAsync()
    {
        Sport = await localStorage.GetItemAsync<int>("sportId");
        Season = await localStorage.GetItemAsync<int>("seasonId");
        Players = await PlayerRepository.GetAllAvailablePlayers(Sport, Season);
    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            //create

            //TeamPlayerModel.PlayerId = currentSeasonId;
            //TeamPlayerModel.TeamSeasonId = selectedTeamId;
            await TeamPlayerRepository.Create(SelectedPlayers, TeamSeasonId);

            if (SelectedPlayers.Any())
            {
                await JsRuntime.ToastrSuccess("Players added successfully");
                await Task.Delay(300);
                NavigationManager.NavigateTo("teamSeasons/teamPlayers/" + TeamSeasonId, true);
            }
            else
            {
                await JsRuntime.ToastrError("No players selected");
            }
            ModalDialogParameters returnParameters = new ModalDialogParameters();
            returnParameters.Add("", TeamPlayerModel);
            ModalDialog.Close(true, returnParameters);
        }
        catch (Exception ex)
        {
            throw ex;

        }
    }
    private async void HandleAdd(PlayerDTO player)
    {
        SelectedPlayers.Add(player);
    }
    private async void HandleRemove(PlayerDTO player)
    {
        SelectedPlayers.Remove(player);
    }
}
